package georouting.traversalAlgorithms;

import georouting.Graph;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.node.CFRNode;
import georouting.node.ImaginaryNode;
import static georouting.traversalAlgorithms.GMP_dev.originTree_;
import java.util.ArrayList;

public class GFG_GMP_CFR extends GFG {
    private boolean done_ = false;

    public GFG_GMP_CFR(Graph g, Node s, Node d, PlanarizationAlgorithm pa) {
        super(g, s, d, pa);
        GMP_dev.visit(_current, _container);
    }
    
    @Override
    public void advanceAlgorithm(){
        if(((CFRNode)_current).hasAssassin())
            done_ = true;
        else if(_current == _destination){
            CFRM_GMP sprinter = new CFRM_GMP(_container, _current, _destination, GMP_dev.originTree_, _pAlg);
            PostOffice.instance().add(sprinter);
            
            done_ = true;
        }
        else{
            super.advanceAlgorithm();
        }
    }
    
    @Override
    public boolean done(){
        return done_;
    }

    @Override
    protected void moveTo(Node n) {
        super.moveTo(n);
        PostOffice.instance().addPacket();
        GMP_dev.visit(_current, _container);
    }
}
